
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[Android] 触屏setOnTouchListener实现图片缩放、移动、绘制和添加水印 / iVAN</title>

    <meta name="description" content="[Android] 触屏setOnTouchListener实现图片缩放、移动、绘制和添加水印     前一篇文章讲述了Android实现图片Matrix矩阵类缩放.旋转.对比度.亮度.饱和度处理,但是真正的图片软件都是使用触屏实现图片缩放.移动.添加水印等功能,所以该篇文章主要通过setOnTouchListener监听实现该功能.希望文章对大家有所帮助. 一.图片缩放实现     首先先简单介绍Android如何实现触屏缩放图片和移动图片,新建TouchImageViw工程.设计XML中activity_main.xml布局: &lt;RelativeLayout xmlns:andr ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">[Android] 触屏setOnTouchListener实现图片缩放、移动、绘制和添加水印</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>    前一篇文章讲述了Android实现图片Matrix矩阵类缩放、旋转、对比度、亮度、饱和度处理,但是真正的图片软件都是使用触屏实现图片缩放、移动、添加水印等功能,所以该篇文章主要通过setOnTouchListener监听实现该功能.希望文章对大家有所帮助.</strong></p>
<h2><strong>一.图片缩放实现</strong></h2>
<p><strong>    首先先简单介绍Android如何实现触屏缩放图片和移动图片,新建TouchImageViw工程.设计XML中activity_main.xml布局:</strong></p>
<p><strong></strong>
<pre>&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools"
    android:id="@+id/container"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    tools:context="com.example.touchimagetest.MainActivity"
    tools:ignore="MergeRootFrame" &gt;
     &lt;!-- 顶部路径 --&gt;
    &lt;RelativeLayout
        android:id="@+id/MyLayout_top"
        android:orientation="horizontal"
        android:layout_width="fill_parent"
        android:layout_height="40dp"
        android:layout_alignParentTop="true"
        android:gravity="center"&gt;
        &lt;TextView
	        android:id="@+id/textView1"
	        android:layout_width="wrap_content"
	        android:layout_height="wrap_content"
	        android:textSize="15sp"
	        android:text="显示图片路径" /&gt;
    &lt;/RelativeLayout&gt;
    &lt;!-- 底部按钮 --&gt;
    &lt;RelativeLayout
        android:id="@+id/MyLayout_bottom"
        android:orientation="horizontal"
        android:layout_width="fill_parent"
        android:layout_height="50dp"
        android:layout_alignParentBottom="true"
        android:gravity="center"&gt;
	    &lt;LinearLayout
	        android:layout_width="match_parent"
	    	android:layout_height="match_parent"
	    	android:orientation="horizontal"
	    	android:layout_alignParentBottom="true" &gt;
	        &lt;Button
		        android:id="@+id/button1"
		        android:layout_width="wrap_content"
		        android:layout_height="match_parent"
		        android:layout_weight="1"
		        android:text="打开" /&gt;
             &lt;/LinearLayout&gt;
	&lt;/RelativeLayout&gt;
	&lt;!-- 显示图片 --&gt;
    &lt;RelativeLayout
        android:id="@+id/Content_Layout"
        android:orientation="horizontal"
        android:layout_width="fill_parent"
        android:layout_height="fill_parent"
        android:layout_above="@id/MyLayout_bottom"
        android:layout_below="@id/MyLayout_top"
        android:background="#EFDFDF"
        android:gravity="center"&gt;
        &lt;ImageView
	        android:id="@+id/imageView1"
	        android:layout_width="fill_parent"
	        android:layout_height="fill_parent"
	        android:layout_gravity="center_horizontal"
			android:scaleType="matrix" /&gt;
    &lt;/RelativeLayout&gt;
&lt;/RelativeLayout&gt;</pre>
<p>   需要注意的是按钮中设置其android:layout_weight="1"属性,因为后面会增加至4个按钮,都设置为1表示每个宽度占水平布局的1/4比例.(图见后)该布局是我非常喜欢的布局,通过相对布局RelativeLayout设置相应的上中下对应图片路径、图片、按钮.<br />
    然后,<strong>在Mainctivity.java中public class MainActivity extends<br />
 Activity函数添加代码如下,添加点击按钮监听事件：</strong></p>
<pre>//自定义变量
private Button openImageBn;           //打开图片
private Bitmap bmp;                   //原始图片
private TextView pathText;            //路径TextView
private String path;                  //存储图片路径
private ImageView imageShow;          //显示图片
private final int IMAGE_CODE = 0;     //打开图片
//触屏缩放图片
private static final int NONE = 0;     //初始状态
private static final int DRAG = 1;     //拖动
private static final int ZOOM = 2;     //缩放
private int mode = NONE;               //当前事件
private float oldDist;
private PointF startPoint = new PointF();
private PointF middlePoint = new PointF();
private Matrix matrix = new Matrix();
private Matrix savedMatrix = new Matrix();

@Override
protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);
    openImageBn = (Button) findViewById(R.id.button1);
    pathText = (TextView) findViewById(R.id.textView1);
    imageShow = (ImageView) findViewById(R.id.imageView1);
    //打开图片
    openImageBn.setOnClickListener(new OnClickListener() {
    	@Override
    	public void onClick(View v) {
    		Intent intent = new Intent(Intent.ACTION_PICK,
    				android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
    		startActivityForResult(intent, IMAGE_CODE);
    	}
    });
}</pre>
<p><strong>    添加intent意图startActivityForResult对应的onActivityResult函数实现打开图片：</strong></p>
<pre>//打开图片
protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	 super.onActivityResult(requestCode, resultCode, data);
	    if(resultCode==RESULT_OK &amp;&amp; requestCode==IMAGE_CODE) {
	    	Uri imageFileUri = data.getData();
	    	DisplayMetrics dm = new DisplayMetrics();
	    	getWindowManager().getDefaultDisplay().getMetrics(dm);
	        int width = dm.widthPixels;    //手机屏幕水平分辨率
	        int height = dm.heightPixels;  //手机屏幕垂直分辨率
	        try {
	            //载入图片尺寸大小没载入图片本身 true
	            BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options();
	            bmpFactoryOptions.inJustDecodeBounds = true;
	            bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
                //outHeight图像高 outWidth图像宽
	            int heightRatio = (int)Math.ceil(bmpFactoryOptions.outHeight/(float)height);
	            int widthRatio = (int)Math.ceil(bmpFactoryOptions.outWidth/(float)width);
	            //inSampleSize表示图片占原图比例 =1表示原图
	            if(heightRatio&gt;1&amp;&amp;widthRatio&gt;1) {
	                if(heightRatio&gt;widthRatio) {
	                    bmpFactoryOptions.inSampleSize = heightRatio;
	                }
	                else {
	                    bmpFactoryOptions.inSampleSize = widthRatio;
	                }
	            }
                //图像真正解码 false
	            bmpFactoryOptions.inJustDecodeBounds = false;
	            bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
	            imageShow.setImageBitmap(bmp);
	            //显示文件路径
	            String[] filePathColumn= {MediaStore.Images.Media.DATA};
	            Cursor cursor = getContentResolver().query(imageFileUri, filePathColumn, null, null, null);
	            cursor.moveToFirst(); //将光标移至开头
	            int columnIndex = cursor.getColumnIndex(filePathColumn[0]); //获得用户选择图片的索引
                path = cursor.getString(columnIndex);
	            cursor.close();
	            pathText.setText("path="+path);

	        } catch(FileNotFoundException e) {
	            e.printStackTrace();
	        }
	    }  //end if
}</pre>
<p><strong>    此时可以实现打开图片,显示的效果如下图所示：<br /></strong>                        <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxMTI3NDc3NjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">    <br />
    <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxMTI5MzkzNzU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"><br /><strong>    然后在onCreate()函数中openImageBn.setOnClickListener打开图片后添加如下代码,通过setOnTouchListener监听实现图片缩放移动功能.PS:这部分网上资料较多,也比较相似.作者参照《Android多媒体开发高级编程》.</strong></p>
<pre>//触屏缩放图片监听 注:XML中修改android:scaleType="matrix"
imageShow.setOnTouchListener(new OnTouchListener() {

	@Override
	public boolean onTouch(View v, MotionEvent event) {
		ImageView view = (ImageView) v;
		switch (event.getAction() &amp; MotionEvent.ACTION_MASK) {
		case MotionEvent.ACTION_DOWN: //手指按下
			savedMatrix.set(matrix);
			startPoint.set(event.getX(), event.getY());
			mode = DRAG;
			break;
		case MotionEvent.ACTION_UP:
		case MotionEvent.ACTION_POINTER_UP:
			mode = NONE;
			break;
		case MotionEvent.ACTION_POINTER_DOWN:
			oldDist = spacing(event); //如果两点距离大于10 多点模式
			if (oldDist &gt; 10f) {
				savedMatrix.set(matrix);
				midPoint(middlePoint, event);
				mode = ZOOM;
			}
			break;
		case MotionEvent.ACTION_MOVE:
			if (mode == DRAG) { //拖动
				matrix.set(savedMatrix);
				matrix.postTranslate(event.getX() - startPoint.x, event.getY() - startPoint.y);
			} else if (mode == ZOOM) { //缩放
				float newDist = spacing(event);
				if (newDist &gt; 10f) {
					matrix.set(savedMatrix);
					float scale = newDist / oldDist;
					matrix.postScale(scale, scale, middlePoint.x, middlePoint.y);
				}
			}
			break;
		} //end switch
		view.setImageMatrix(matrix);
		return true;
	}
	//两点距离
	private float spacing(MotionEvent event) {
		float x = event.getX(0) - event.getX(1);
		float y = event.getY(0) - event.getY(1);
		return FloatMath.sqrt(x * x + y * y);
	}
	//两点中点
	private void midPoint(PointF point, MotionEvent event) {
		float x = event.getX(0) + event.getX(1);
		float y = event.getY(0) + event.getY(1);
		point.set(x / 2, y / 2);
	}
});</pre>
<p><strong>   <br />
运行结果如下图所示：<br /></strong>                                                <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxMTQyMDI1MTU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">       <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxMTQyMzU1MDA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"><br /><strong>    下面讲讲作者遇到的几个问题及需要注意的几个地方：<br />
    1.如何使用RelativeLayout进行布局,上面布局非常优秀,是我参照了郑海波学长一个代码例子的布局,个人觉得比较喜欢.<br />    2.在图像缩放的时候需要设置ImageView的属性android:scaleType="matrix",这里涉及到前一篇讲述的Matrix矩阵类的知识,但是使用该类后图像如何居中呢?<br />    设置其父布局为android:gravity="center"是不行的,作者查阅很多资料,有两种方法：一种是设置ImageView的scaleType属性为center,在缩放时代码设置为matrix,感觉不太好;另一种是通过下面的代码可以实现居中显示,但是在缩放时需要注意设置其图片左上角显示位置,否则会出现跳动到(0,0)现象.</strong></p>
<pre>//设置图片居中 起点=未使用屏幕/2=(屏幕分辨率-图片宽高)/2
int widthCenter=imageShow.getWidth()/2-bmp.getWidth()/2;
int heightCenter=imageShow.getHeight()/2-bmp.getHeight()/2;
Matrix matrix = new Matrix();
matrix.postTranslate(widthCenter, heightCenter);
imageShow.setImageMatrix(matrix);
imageShow.setImageBitmap(alteredBitmap);</pre>
<p><strong>    希望高手能提供更好的方法,因为跳动现象,我自己也会继续去学习.<br />
    3.图片ImageView设置了setOnTouchListener监听,能实现缩放图片,那么如果还点击一个按钮"文字"后实现的是拖放文字框,点击"绘制"是在图像上绘制图片,怎么实现呢?点击一个按钮怎样实现一个触摸监听呢?<br />    由于这个很难查阅资料,像美图秀秀哪样的功能,所以我自己只能想到通过修改一个变量赋值判断触屏监听执行那个方法,自定义函数private int flagOnTouch=0,当其1-显示图片,2-添加文字,3-缩放图片,4-画图.在点击按钮事件中对其进行赋值,在</strong><strong>setOnTouchListener中判断.(希望提供更好的方法)<br />
    4.缩放图片时最好设置最小的边界,当缩小当一定范围尺寸固定不变,放大最好也有越界等处理.</strong></p>
<h2><strong>二.原理介绍</strong></h2>
<p><strong>   <strong>下面讲述触摸事件的一些基础知识,方便巩固上面的工程.</strong><br />
    Android许多UI元素都继承View类,该类支持触摸,该方法是setOnTouchListener,其接受一个实现OnTouchListener接口对象作为参数.每当触摸ImageView调用活动中的onTouch方法,再通过查看传递到onTouch方法中的MotionEvent对象,可以确定发生哪种类型的触摸,可调用getAction方法:<br />
    MotionEvent.ACTION_DOWN:表明视图已经接收一次触摸,按下时触发<br />
    MotionEvent.ACTION_UP:表明视图停止接受一次触摸,被放开时触发<br />
    MotionEvent.ACTION_POINTER_DOWN:当屏幕上已经有一点被按住,再按下其他点时触发<br />
    MotionEvent.ACTION_POINTER_UP:当屏幕上有多个点被按住,松开其中一个点时触发(即非最后一个点被放开时)<br />
    MotionEvent.ACTION_MOVE:表明在发生一次触摸之后,在ACTION_UP之前发生了某种移动<br />
    MotionEvent.ACTION_CANCEL:表明触摸已经被取消,因此该忽略它<br />
    同时可以调用MotionEvent对象上的getX和getY来确定触摸事件发生的位置.<br />
    如上面的代码,当ACTION_DOWN手指第一次按下时设置mode=DRAG,当ACTION_POINTER_DOWN再按下一个手指时判断距离大于10设置mode=ZOOM,当ACTION_MOVE移动时判断两指为缩放,一指为移动即可实现.在通过新坐标和老坐标设置图像变换.<strong>参考《Android多媒体开发高级编程》</strong><br />
    (PS:作者才接触Android一个星期,说起来很简单啊!但做起来还是非常难的~)</strong></p>
<h2><strong>三.工程实现详解</strong></h2>
<p><strong>    上面简单的缩放功能与基本原理(干货)都讲述了,读者可以自己去实现功能,下面就如何实现触摸setOnTouchListener图片缩放、移动、绘制和添加水印.都是基于上面代码修改实现的.需要注意的是在图片修改时需要创建一个新的Bitmap alteredBitmap(bmp图片)、Canvas canvas(画布)、Paint paint(画刷)实现.</strong></p>
<h3>    1.图片缩放和图片绘制</h3>
<p><strong>    首先,为XML布局中修改为4个新的按钮,即"打开"、"文字"、"缩放"、"画图".</strong></p>
<pre>&lt;Button
	 android:id="@+id/button1"
	 android:layout_width="wrap_content"
	 android:layout_height="match_parent"
	 android:layout_weight="1"
	 android:text="打开" /&gt;
&lt;Button
	 android:id="@+id/button2"
	 android:layout_width="wrap_content"
	 android:layout_height="match_parent"
	 android:layout_weight="1"
	 android:text="文字" /&gt;
&lt;Button
	 android:id="@+id/button3"
	 android:layout_width="wrap_content"
	 android:layout_height="match_parent"
	 android:layout_weight="1"
	 android:text="缩放" /&gt;
&lt;Button
	 android:id="@+id/button4"
	 android:layout_width="wrap_content"
	 android:layout_height="match_parent"
	 android:layout_weight="1"
	 android:text="画图" /&gt;</pre>
<p><strong>    在上面的自定义变量中添加新的变量,如下：</strong></p>
<pre>//新增按钮
private Button wordAddBn;              //添加文字
private Button changeImageBn;          //缩放图片
private Button drawImageBn;            //绘制图片
//图片处理时显示备份
private Bitmap alteredBitmap;          //图片
private Canvas canvas;                 //画布
private Paint paint;                   //画刷
private RelativeLayout layout;
//标识变量  1-显示图片 2-添加文字 3-缩放图片 4-画图
private int flagOnTouch = 0;      </pre>
<p><strong>    然后修改打开图片函数,为其创建一个alteredBitmap图像,后面的添加文字和绘制画图都是在此基础上修改：</strong></p>
<pre>//打开图片
protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	 super.onActivityResult(requestCode, resultCode, data);
	    if(resultCode==RESULT_OK &amp;&amp; requestCode==IMAGE_CODE) {
	    	Uri imageFileUri = data.getData();
	    	DisplayMetrics dm = new DisplayMetrics();
	    	getWindowManager().getDefaultDisplay().getMetrics(dm);
	        int width = dm.widthPixels;    //手机屏幕水平分辨率
	        int height = dm.heightPixels;   //手机屏幕垂直分辨率
	        try {
		        //标识变量=1 图片显示
                flagOnTouch = 1; 
	            //载入图片尺寸大小没载入图片本身 true
	            BitmapFactory.Options bmpFactoryOptions = new BitmapFactory.Options();
	            bmpFactoryOptions.inJustDecodeBounds = true;
	            bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
	            int heightRatio = (int)Math.ceil(bmpFactoryOptions.outHeight/(float)height);
	            int widthRatio = (int)Math.ceil(bmpFactoryOptions.outWidth/(float)width);
	            //inSampleSize表示图片占原图比例 =1表示原图
	            if(heightRatio&gt;1&amp;&amp;widthRatio&gt;1) {
	                if(heightRatio&gt;widthRatio) {
	                    bmpFactoryOptions.inSampleSize = heightRatio;
	                }
	                else {
	                    bmpFactoryOptions.inSampleSize = widthRatio;
	                }
	            }
                //图像真正解码 false
	            bmpFactoryOptions.inJustDecodeBounds = false;
	            bmp = BitmapFactory.decodeStream(getContentResolver().openInputStream(imageFileUri), null, bmpFactoryOptions);
	            //imageShow.setImageBitmap(bmp);
	            //显示文件路径
	            String[] filePathColumn= {MediaStore.Images.Media.DATA};
	            Cursor cursor = getContentResolver().query(imageFileUri, filePathColumn, null, null, null);
	            cursor.moveToFirst(); //将光标移至开头
	            int columnIndex = cursor.getColumnIndex(filePathColumn[0]); //获得图片索引值
	            path = cursor.getString(columnIndex);
	            cursor.close();
	            pathText.setText("path="+path);
	           //加载备份图片
	            alteredBitmap = Bitmap.createBitmap(bmp.getWidth(), bmp
						.getHeight(), bmp.getConfig());
				canvas = new Canvas(alteredBitmap);  //画布
				paint = new Paint(); //画刷
				paint.setColor(Color.GREEN);
				paint.setStrokeWidth(5);
				paint.setTextSize(30);
				paint.setTypeface(Typeface.DEFAULT_BOLD);  //无线粗体
				matrix = new Matrix();
				canvas.drawBitmap(bmp, matrix, paint);
				imageShow.setImageBitmap(alteredBitmap);

	        } catch(FileNotFoundException e) {
	            e.printStackTrace();
	        }
	    }  //end if
}</pre>
<p><strong>    然后在onCreate中添加图片缩放和绘制图片函数,代码如下：</strong></p>
<p><strong></strong>
<pre>//缩放图片 点击按钮"缩放"
changeImageBn = (Button) findViewById(R.id.button3);
changeImageBn.setOnClickListener(new OnClickListener() {
	@Override
	public void onClick(View v) {
		flagOnTouch = 3; //缩放
	}
});
//绘制画图 点击按钮"绘制"
drawImageBn = (Button) findViewById(R.id.button4);
drawImageBn.setOnClickListener(new OnClickListener() {
	@Override
	public void onClick(View v) {
		flagOnTouch = 4; //绘图
		//画图 图片移动至(0,0) 否则绘图线与手指存在误差
		matrix = new Matrix();
		matrix.postTranslate(0, 0);
		imageShow.setImageMatrix(matrix);
		imageShow.setImageBitmap(alteredBitmap);
        canvas.drawBitmap(bmp, matrix, paint);
	}
 });</pre>
<p><strong>    然后修改 imageShow.setOnTouchListener(new OnTouchListener())函数,实现点击不同按钮响应不同的触摸事件：</strong></p>
<pre>//触屏缩放图片监听 注:XML中修改android:scaleType="matrix"
imageShow.setOnTouchListener(new OnTouchListener() {
	//设置两个点 按下坐标(downx, downy)和抬起坐标(upx, upy)
	float downx = 0;
	float downy = 0;
	float upx = 0;
	float upy = 0;
	//触摸事件
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		ImageView view = (ImageView) v;
		if(flagOnTouch == 1) { //显示图片
			return true;
		}
		else if(flagOnTouch == 3)  { //图片缩放
			switch (event.getAction() &amp; MotionEvent.ACTION_MASK) {
			case MotionEvent.ACTION_DOWN: //手指按下
				savedMatrix.set(matrix);
				startPoint.set(event.getX(), event.getY());
				mode = DRAG;
				break;
			case MotionEvent.ACTION_UP:
			case MotionEvent.ACTION_POINTER_UP:
				mode = NONE;
				break;
			case MotionEvent.ACTION_POINTER_DOWN:
				oldDist = spacing(event); //如果两点距离大于10 多点模式
				if (oldDist &gt; 10f) {
					savedMatrix.set(matrix);
					midPoint(middlePoint, event);
					mode = ZOOM;
				}
				break;
			case MotionEvent.ACTION_MOVE:
				if (mode == DRAG) { //拖动
					matrix.set(savedMatrix);
					matrix.postTranslate(event.getX() - startPoint.x, event.getY() - startPoint.y);
				} else if (mode == ZOOM) { //缩放
					float newDist = spacing(event);
					if (newDist &gt; 10f) {
						matrix.set(savedMatrix);
						float scale = newDist / oldDist;
						matrix.postScale(scale, scale, middlePoint.x, middlePoint.y);
					}
				}
				break;
			} //end switch
			view.setImageMatrix(matrix);
			return true;
		}
		else if(flagOnTouch == 2) { //图片文字添加
			return true;
    	}
		else if(flagOnTouch == 4) { //绘制图像
			switch (event.getAction()) {
				case MotionEvent.ACTION_DOWN:
					downx = event.getX();
					downy = event.getY();
					break;
				case MotionEvent.ACTION_MOVE:
					upx = event.getX();
					upy = event.getY();
					canvas.drawLine(downx, downy, upx, upy, paint);
					imageShow.invalidate();
					downx = upx;
					downy = upy;
					break;
				case MotionEvent.ACTION_UP:
					upx = event.getX();
					upy = event.getY();
					canvas.drawLine(downx, downy, upx, upy, paint);
					imageShow.invalidate();
					break;
				case MotionEvent.ACTION_CANCEL:
					break;
				default:
					break;
				}
				return true;
		}
    	else {
    		return false;
    	}
	}  //end  onTouch
	//两点距离
	private float spacing(MotionEvent event) {
		float x = event.getX(0) - event.getX(1);
		float y = event.getY(0) - event.getY(1);
		return FloatMath.sqrt(x * x + y * y);
	}
	//两点中点
		private void midPoint(PointF point, MotionEvent event) {
			float x = event.getX(0) + event.getX(1);
			float y = event.getY(0) + event.getY(1);
			point.set(x / 2, y / 2);
		}
});</pre>
<p><strong>    此时图像显示的效果如下图所示,点击"打开"按钮只能打开图片,点击"画图"按钮能在原图上绘制,在此点击"画图"可以进行重绘.点击"缩放"还能放大移动.但是点击"画图"只能移动到(0,0)点,担心坐标变换出现不一致现象.<br /></strong>   <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxNjExMzI2OTA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">      <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxNjExNTcwNDI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">   <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxNjE1MTYxMDk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"> </p>
<h3><strong>    2.添加水印</strong></h3>
<p><strong>    添加如下函数实现添加水印,主要是通过调用drawText绘制内容：</strong></p>
<pre>//添加水印文字
wordAddBn = (Button) findViewById(R.id.button2);
layout = (RelativeLayout) findViewById(R.id.Content_Layout);
wordAddBn.setOnClickListener(new OnClickListener() {
	@Override
	public void onClick(View v) {
		flagOnTouch = 2;
		//添加文字
		Bitmap bmpTemp = Bitmap.createBitmap(bmp.getWidth(), bmp.getHeight(), bmp.getConfig());
        Canvas cv = new Canvas(bmpTemp);
        Paint p = new Paint();
        Typeface font = Typeface.create("宋体", Typeface.BOLD);
        p.setColor(Color.BLUE);
        p.setTypeface(font);
        p.setTextSize(40);
        cv.drawBitmap(bmp, 0, 0, p);
        imageShow.setImageBitmap(bmpTemp);
        cv.drawText("eastmount", 40, 40, p);
        cv.save(Canvas.ALL_SAVE_FLAG);
        cv.restore();
	}
});</pre>
<p><strong>    显示效果如下图所示：<br /></strong>                                         <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxNzI4NTIyOTY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg">                <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEwMjgxNzI5MzExNTY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2UldGemRHMXZkVzUwL2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"><br /><strong>    我想实现的效果是点击"文字"按钮后弹出键盘输入文字水印,并且可以拖动文字的效果.但效果不是很好如右图,所以没写出来,只能添加固定的文字.下面的代码是添加EditView代码仅供参考：</strong></p>
<pre>//键盘添加EditText
private EditText createEditText() {
	EditText et = new EditText(this);
	LayoutParams params = new LayoutParams(LayoutParams.WRAP_CONTENT,
			LayoutParams.WRAP_CONTENT);
	et.setLayoutParams(params);
	return et;
}
//键盘实现
private void addWigdet(RelativeLayout layout, int x, int y, EditText v) {
	RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(
			LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
	params.leftMargin = x;
	params.topMargin = y;
	layout.addView(v, params);
	v.setFocusable(true);
	v.setFocusableInTouchMode(true);
	v.requestFocus();
	v.setBackgroundColor(Color.BLACK);
	v.setTextColor(Color.WHITE);
	v.getBackground().setAlpha(160);
	InputMethodManager inputManager = (InputMethodManager)
			v.getContext().getSystemService(Context.INPUT_METHOD_SERVICE);
	inputManager.showSoftInput(v, 0);
}</pre>
<p><strong>    然后在触摸事件onTouch中添加addWigdet(layout, x, y, createEditText())代码即可实现,我的if(flagOnTouch==2)没有填写任何内容,就是因为预览效果不是很好,读者自己可以去尝试完成~</strong></p>
<h3><strong>    3.长按保存</strong></h3>
<p>    上面的代码你可能觉得当添加文字或绘制后,在次点击图片为啥没变化,那时因为我没有保存.我想实现的功能是点击图片长按保存,在刷新下图片即可完成修改.<br />
     <strong> 最后希望该文章对大家有所帮助,尤其是Android初学者.该文章是讲述Android使用监听事件setOnTouchListener实现触摸处理图片的基础文章,包括缩放移动图片、添加水印、绘制图片等.初学Android如果有不足或错误地方,请见谅~<br />
    参考资料《Android多媒体开发高级编程 著：Shawn Van Every》<br /></strong><strong>    下载地址:<a href="http://download.csdn.net/detail/eastmount/8091941" rel="external nofollow noreferrer">http://download.csdn.net/detail/eastmount/8091941</a><br />(By:Eastmount 2014-10-28 夜2点  </strong><strong></strong><a href="http://blog.csdn.net/eastmount" rel="external nofollow noreferrer"><strong>http://blog.csdn.net/eastmount</strong></a><strong>)</strong> <br />
参考资料和相关博文:<br />    <a href="http://blog.csdn.net/tangcheng_ok/article/details/6859503" rel="external nofollow noreferrer">Android截图以及加水印Demo By:tangcheng_ok</a><br />    <a href="http://wenku.baidu.com/link?url=LCPGDhuyTSglwnELb6P7pHaX68Xzh6U66CRwkNIStt6Pa_GW5z-i0dwOjkEMV5nP1b3D0CG3B37W_KmyNZtBLFGk9t4FRGymoPmBpqAF9oK" rel="external nofollow noreferrer">Android<br />
 自定义View消除锯齿实现图片旋转,添加边框及文字说明</a><br />    <a href="http://blog.csdn.net/wuwo333/article/details/8057294" rel="external nofollow noreferrer">Android图片查看支持双击放大缩小、多点触摸(边界处理) By:TMajier</a><br />    <a href="http://blog.csdn.net/lonelyroamer/article/details/25497737" rel="external nofollow noreferrer">Android浏览图片，点击放大至全屏效果 By:roamer</a><br />
    <a href="http://blog.csdn.net/barryhappy/article/details/7392326" rel="external nofollow noreferrer">我的Android笔记（十三）Muilti-touch 双指缩放的实现探索 By:barryhappy</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:48:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>[Android] 触屏setOnTouchListener实现图片缩放、移动、绘制和添加水印的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL0YDM.html" rel="bookmark">Android触屏测试实例代码&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例详细描述了Android触屏测试代码,可实现对触屏的点击.移动.离开等事件的处理,对于Android初学者有很好的借鉴价值. 具体功能代码如下: package com.test; import android.app.Activity; import android.os.Bundle; import android.util.DisplayMetrics; import android.util.Log; import android.view.MotionEvent; import			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76qNrp.html" rel="bookmark">Android触屏测试实例代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例详细描述了Android触屏测试代码,可实现对触屏的点击.移动.离开等事件的处理,对于Android初学者有很好的借鉴价值. 具体功能代码如下: package com.test; import android.app.Activity; import android.os.Bundle; import android.util.DisplayMetrics; import android.util.Log; import android.view.MotionEvent; import			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5o4Qnb.html" rel="bookmark">android触屏中心位置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 android触屏中心位置 使用下面的方法触发android的触屏事件.需要辨识中心触屏,怎么样判断用户触摸了屏幕的中间位置? @Overridepublic boolean onTouch(View v MotionEvent mev) {int width = v.getWidth();int height = v.getHeight();float x = mev.getX();float y = mev.getY();String msg;if (x &lt; width / 2)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MydJGvb.html" rel="bookmark">android 触屏-怎么依靠android上层来使触屏左右倒置，并且不影响上下？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎么依靠android上层来使触屏左右倒置,并且不影响上下? 不改动底层驱动,依靠修改上层来实现触屏左右倒置的效果! 其实就是我有个板子左右倒过来了,底层我能够解决,但是上层怎么去弄?麻烦解答解答!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBKvXOM.html" rel="bookmark">Android截屏保存png图片的实例代码&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: import java.io.FileNotFoundException;import java.io.FileOutputStream;import java.io.IOException; import android.app.Activity;import android.graphics.Bitmap;import android.graphics.Rect;import android.util.Log;import android.view.View; publ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M067G7z.html" rel="bookmark">Android截屏保存png图片的实例代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下:import java.io.FileNotFoundException;import java.io.FileOutputStream;import java.io.IOException; import android.app.Activity;import android.graphics.Bitmap;import android.graphics.Rect;import android.util.Log;import android.view.View; publi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmm2Zjp.html" rel="bookmark">android 触屏的震动响应接口调用方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				调用native 方法来开启和关闭vibrator: native static void vibratorOn(long milliseconds); native static void vibratorOff(); 调用方法如下: VibratorService.vibratorOn()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj89a6p.html" rel="bookmark">Android应用中实现手势控制图片缩放的完全攻略&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述现在app中,图片预览功能肯定是少不了的,用户基本已经形成条件反射,看到小图,点击看大图,看到大图两个手指开始进行放大,放大后,开始移动到指定部位~~~ 我相信看图的整个步骤,大家或者说用户应该不希望被打断把~~~&quot;我擦,竟然不能放大,什么玩意,卸了~~&quot; , &quot;我擦,竟然不能移动,留有何用,卸了~~&quot;. 哈~所以对于图片的预览,一来,我们要让用户爽:二来,我们作为开发者,也得知道如何实现~~~ 想要做到图片支持多点触控,自由的进行缩放.平移,需要了解几个知			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYN0v9p.html" rel="bookmark">手机端图片缩放旋转全屏查看PhotoSwipe&period;js插件实现&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PhotoSwipe 是专为移动触摸设备设计的相册/画廊.兼容所有iPhone.iPad.黑莓6+,以及桌面浏览器.底层实现基于HTML/CSS/JavaScript,是一款免费开源的相册产品. 为谁而用 让移动站点的相册体验和原生App一样的设计师和开发者. 绝佳特性 PhotoSwipe提供给用户一个熟悉又直观的相册交互界面. 官方网站 http://www.photoswipe.com/ 源码示例 http://github.com/downloads/codecomputerlove/P			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMymR8M.html" rel="bookmark" class="title">CSS兼容性技巧大全（二）</a>
					<div>
						网页制作Webjx文章简介:6.DIV浮动IE文本产生3象素的bug 左边对象浮动,右边采用外补丁的左边距来定位,右边对象内的文本会离左边有3px的间距. #box{ float:left; widt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz739qz.html" rel="bookmark" class="title">在你的ASP中使用类&lpar;class&rpar;</a>
					<div>
						介绍作者:http://www.aspcn.com 飞刀 在不入前的一天,当我为了解决一个语法问题来翻阅VBscript文档时,偶然间发现在了下面的一句话: Class Statement Decla ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP3LlM.html" rel="bookmark" class="title">网站建设&OpenCurlyDoubleQuote;创意&rdquo;赢销：标题及内容描述不可轻视</a>
					<div>
						何谓创意?对于网站建设与搜索引擎营销来说,创意就是某个网站在搜索引擎中的表现.比如网站的标题.网站的内容描述等等.虽然百度及谷歌都纷纷表态,声明网站权重与网站内容描述关系不大,但是富有创意的内容描述总 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvkVVp.html" rel="bookmark" class="title">valgrind的使用方法</a>
					<div>
						1.下载http://valgrind.org/ 2.解压后进入目录执行./autogen.sh 3.执行./configure 在此可以指定安装目录加 --prefix=/usr/local指定 4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62KZAM.html" rel="bookmark" class="title">如何在电视机上使用多米音乐？</a>
					<div>
						在确保网络成功连接的情况下,进入创维电视的主界面,选择&quot;音乐相册&quot;栏目下的'在线多米音乐',即可进入多米音乐.使用遥控器菜单键.方向键和退出键进行操作.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGPlWp.html" rel="bookmark" class="title">360免费WiFi已连接运营商WiFi浏览器提示需登录（或提示要求输入手机号）？</a>
					<div>
						  只有通过本软件接入运营商WiFi才能自动登录并免费上网; 提示需登录时,建议断开现有连接,并用「360免费WiFi」重新接入CMCC.ChinaUnicom.ChinaNet就能自动登录并免费上网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6DK4b.html" rel="bookmark" class="title">Windows XP系统中如何恢复被破坏的文件</a>
					<div>
						  具体方法: 在Windows XP的安装盘中搜索被破坏的文件,需要注意的是,文件名的最后一个字符用底线&quot;_&quot;代替,例如:如果要搜索&quot;Notepad.exe&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NmxAM.html" rel="bookmark" class="title">Nightmare基于phantomjs的自动化测试套件</a>
					<div>
						今天将介绍一款自动化测试套件名叫nightmare,他是一个基于phantomjs的测试框架,一个基于phantomjs之上为测试应用封装的一套high level API.其API以goto, re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQryyoM.html" rel="bookmark" class="title">android-关于Android studio的问题</a>
					<div>
						问题描述 关于Android studio的问题 我环境配置没问题这种怎么回事?在DOS下Java_visions 是正常 解决方案 http://jingyan.baidu.com/article/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQGnWp.html" rel="bookmark" class="title">初学者-想新建一个空白应用程序，可是无法加载设计器，</a>
					<div>
						问题描述 想新建一个空白应用程序,可是无法加载设计器, 我是一个C# 的初学者,在创建一个&quot;window 应用商店&quot;-&quot;空白应用程序&quot;后无法加载设计器,说发生了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL77KkM.html" rel="bookmark" class="title">web开发-vs2013中怎么用asp&period;net处理程序做防盗链处理</a>
					<div>
						问题描述 vs2013中怎么用asp.net处理程序做防盗链处理 除了重写url之外,asp.net处理程序怎么防止用户盗用网站图片,css,js等资源文件 解决方案 不用重写url,只要写httph ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZePBz.html" rel="bookmark" class="title">gradle-Gradle 脚本中的项目依赖问题</a>
					<div>
						问题描述 Gradle 脚本中的项目依赖问题 不知道大家采用android studio开发的时候,有没有用到项目依赖的脚本,就是依赖在一个库工程,进行编译,为啥每次编译都要执行5分多钟,太慢了,有没 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDBwqz.html" rel="bookmark" class="title">吉林大学老师蓝牙点名被赞&OpenCurlyDoubleQuote;有创意&rdquo;</a>
					<div>
						&quot;哥们,我不想去上课,你把我手机带过去吧,记得开蓝牙哦,亲!&quot;这一&quot;逃课新招&quot;,应对的是老师的&quot;点名新招&quot;蓝牙点名.近日,吉林大学珠海学院计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94lvKb.html" rel="bookmark" class="title">中国电信谢朝阳：我们要做云计算正规军</a>
					<div>
						图注:中国电信 云计算公司总裁 谢朝阳博士(蒋湘辉 摄)ZDNet至顶网软件频道消息(文/蒋湘辉) 2012年3月正式挂牌成立的中国电信云计算公司在云计算业界引起了广泛关注,该公司总裁谢朝阳博士是国内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoKlAM.html" rel="bookmark" class="title">《Total Commander：万能文件管理器》&mdash;&mdash;第3&period;3节&period;闭眼定位术：三招直达、两招往复</a>
					<div>
						第3.3节.闭眼定位术:三招直达.两招往复 思考题:为什么TC的操作比资源管理器快捷?为什么有人喜爱五笔打单字?为什么键盘操作比鼠标快捷?请仔细思考一下,并试图去寻找最本质的要点! 对上面的思考题,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZGVop.html" rel="bookmark" class="title">http&colon;&sol;&sol;www&period;88tjh&period;com&sol; 的弹出窗口 是从那一段JS 来的？</a>
					<div>
						问题描述 http://www.88tjh.com/ 的弹出窗口 是从那一段JS 来的? 应该如何修改?弹出的窗口是:http://union.zhubajie.com/land/keyizuo-zd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQ6Pkp.html" rel="bookmark" class="title">求解，我在MVC中使用webbrowser截网页加载不了JS是什么情况？</a>
					<div>
						问题描述 报这三个错,求解啊! 解决方案 解决方案二:没人吗..自己顶一下解决方案三:没人吗?还是我没说清楚--是这样的,我在controller里调用webbrowser截图本地网站但是它执行JS代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX03k4p.html" rel="bookmark" class="title">Bing和baidu的url详细参数！</a>
					<div>
						问题描述 最近要做个爬虫,求大神赐教Bing和baidu的url详细参数! 解决方案 解决方案二:不知道,我的下载资源里有一个简单的爬出程序,java的解决方案三:LZ可以百度一下nutch和solr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nk7Nb.html" rel="bookmark" class="title">用java实现类似发帖、跟帖的一个问题交流功能模块，求大神帮助！！</a>
					<div>
						问题描述 用java实现类似发帖.跟帖的一个问题交流功能模块,求大神帮助!! 解决方案 解决方案二:你还会别指望了,大神一般都是自己弄自己东西的,你学习吧,慢慢学解决方案三:你去下个bbs,很多jav ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Q5QdM.html" rel="bookmark" class="title">详解微信小程序开发之下拉刷新 上拉加载&lowbar;javascript技巧</a>
					<div>
						微信小程序中的下拉刷新,上拉加载的功能很常见,目前我知道的有两种可行的方法,一是scroll-view,二是整个页面刷新.今天说说第一种,自己造轮子,难免有些瑕疵,日后慢慢完善. 上gif: 原理:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNGJ5p.html" rel="bookmark" class="title">jquery比较简洁的软键盘特效实现方法&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery比较简洁的软键盘特效实现方法.分享给大家供大家参考.具体实现方法如下: 运行效果图如下: 1. html主要部分如下: 复制代码 代码如下: &lt;div id=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boLBO3M.html" rel="bookmark" class="title">如何在子页面关闭时刷新父页面</a>
					<div>
						问题描述 我的子页面是一个没有工具栏没有菜单栏的页面不是提示窗口我的父页面是在框架中我不想刷新框架怎么办啊在关闭子页面时刷新下父页面 解决方案 解决方案二: 解决方案三://&lt;ahref='ja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWa7Op.html" rel="bookmark" class="title">重度果粉必备 可同时为16台iPad充电的行李箱</a>
					<div>
						Insync Transport Case 是一个非常耐用的多功能行李箱,不过这个行李箱并不是用来装普通行李的,它是用来装iPad的!!这个行李箱一共可容纳16台iPad和1台13寸的笔记本电脑,在连 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baqLwqb.html" rel="bookmark" class="title">分享工作中遇到的问题积累经验 事务日志太大导致insert不进数据</a>
					<div>
						原文:分享工作中遇到的问题积累经验 事务日志太大导致insert不进数据 分享工作中遇到的问题积累经验 事务日志太大导致insert不进数据 今天开发找我,说数据库insert不进数据,叫我看一下 他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRd3jez.html" rel="bookmark" class="title">2025年全球5G室内无线市值将达5&period;09亿美元</a>
					<div>
						根据市场调研公司ABI Research最新调查结果显示,包括有源分布式天线系统(DAS).被动式DAS以及中继器在内的全球室内无线系统设备市场预计将在2025年突破100亿美元. 然而,其中5G室内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8GX6BM.html" rel="bookmark" class="title">甲骨文推公共云服务 批评Salesforce是蟑螂屋</a>
					<div>
						甲骨文CEO拉里·埃里森(Larry http://www.aliyun.com/zixun/aggregation/16528.html&quot;&gt;Ellison)周四在OpenWorld大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDjny0M.html" rel="bookmark" class="title">移动物联网技术助力嘉兴智慧办公</a>
					<div>
						日前,嘉兴港航局三塔港航管理检查站执法人员小王轻轻地在一台平板电脑上点击几下,在他面前驶过的船舶的详细信息就迅速出现在平板电脑界面上.而以前,港航执法人员在日常巡航时要求船主提供相关证件后进行检查,巡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z751QRM.html" rel="bookmark" class="title">关于JAVA语言界面实现的简洁方便性</a>
					<div>
						问题描述 我是一个大学生,学软件的.在学JAVA的过程中,我对JAVA跟别的语言的不同之处在于它的界面.JAVA有几种不同的界面分布方式和相应代码,我都对其实现有了一些深入了解.但是在其过程中,我感觉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOkVZvz.html" rel="bookmark" class="title">日本企业走出去：曾经的教训和经验</a>
					<div>
						● 日本专家谈&quot;走出去&quot; 日本企业&quot;走出去&quot;的经验之一:只有把不同见解.不同管理方式的公司整合起来才能创造出协同效应,也就是说,那些只想以获取为目标,或者是并不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdBYr6b.html" rel="bookmark" class="title">怎样用语音控制程序呢 在线给分</a>
					<div>
						问题描述 怎样用语音控制程序呢我想用语音控制实现一些小的功能 解决方案 解决方案二:比如用语音输入字符等最好有源码谢谢					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
